"""\
Error documents service
"""

import logging

from bn import AttributeDict, absimport
from configconvert.internal import eval_import

log = logging.getLogger(__name__)

def make_renderer(name, tempate_name='template'):
    def render(service):
        template = 'error.dwt' 
        regions = {
            'heading': 'Error '+str(service[name].status_code),
            'doctitle': '<title>Error '+str(service[name].status_code)+'</title>',
            'content': str(service[name].status_message),
        }
        service.http.response.status = str(service[name].status_code)+' Error'
        service.http.response.headers = [('Content-type', 'text/html')]
        service.http.response.body = [
            service.template.render(
                template, 
                regions, 
            )
        ]
    return render

def errorDocumentService(render=None):
    def errorDocumentService_constructor(service):
        name = service.name
        if service.boot.option.has_key(name):
            render = eval_import(service.boot.option[name]['render'])
        else:
            render = make_renderer(name)
        service.config[name] = AttributeDict(
            dict(render=render)
        )
        def start(service):
            def render(code=None, message=None, status=None):
                try:
                    if status is None:
                        status = service.http.response.status
                    parts = status.split(' ')
                    if code is None:
                        code = int(parts[0])
                    if message is None:
                        message = ' '.join(parts[1:])
                    service[name]['status_code'] = code
                    service[name]['status_message'] = message
                    return service.config[name].render(service)
                except Exception, e:
                    log.error('%r', e)
                    # Display the error document
                    service.http.response.status = '500 Internal Server Error'
                    service.http.response.headers = [('Content-type', 'text/html')]
                    service.http.response.body = ['''
    <html>
    <head><title>%(status)s</title></head>
    <body>
    <h1>Error %(code)s</h1>
    <p>%(message)s</p>
    </body>     
    </html>'''%dict(status=status, code=code, message=message)]
                
            service[name] = AttributeDict()
            service[name]['render'] = render
        return AttributeDict(start=start)
    return errorDocumentService_constructor
    
